/* process.c generated by valac 0.44.1, the Vala compiler
 * generated from process.vala, do not modify */

/* process.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glibtop/procstate.h>
#include <glibtop.h>
#include <glibtop/procuid.h>

#define USAGE_TYPE_PROCESS (usage_process_get_type ())
#define USAGE_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PROCESS, UsageProcess))
#define USAGE_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PROCESS, UsageProcessClass))
#define USAGE_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PROCESS))
#define USAGE_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PROCESS))
#define USAGE_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PROCESS, UsageProcessClass))

typedef struct _UsageProcess UsageProcess;
typedef struct _UsageProcessClass UsageProcessClass;
typedef struct _UsageProcessPrivate UsageProcessPrivate;
typedef enum  {
	USAGE_PROCESS_STATUS_RUNNING,
	USAGE_PROCESS_STATUS_SLEEPING,
	USAGE_PROCESS_STATUS_DEAD
} UsageProcessStatus;

#define USAGE_TYPE_PROCESS_STATUS (usage_process_status_get_type ())
enum  {
	USAGE_PROCESS_0_PROPERTY,
	USAGE_PROCESS_PID_PROPERTY,
	USAGE_PROCESS_CMDLINE_PROPERTY,
	USAGE_PROCESS_UID_PROPERTY,
	USAGE_PROCESS_CPU_LOAD_PROPERTY,
	USAGE_PROCESS_X_CPU_LOAD_PROPERTY,
	USAGE_PROCESS_CPU_LAST_USED_PROPERTY,
	USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY,
	USAGE_PROCESS_LAST_PROCESSOR_PROPERTY,
	USAGE_PROCESS_MEM_USAGE_PROPERTY,
	USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY,
	USAGE_PROCESS_STATUS_PROPERTY,
	USAGE_PROCESS_NUM_PROPERTIES
};
static GParamSpec* usage_process_properties[USAGE_PROCESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UsageProcess {
	GObject parent_instance;
	UsageProcessPrivate * priv;
};

struct _UsageProcessClass {
	GObjectClass parent_class;
};

struct _UsageProcessPrivate {
	GPid _pid;
	gchar* _cmdline;
	guint _uid;
	gdouble _cpu_load;
	gdouble _x_cpu_load;
	guint64 _cpu_last_used;
	guint64 _x_cpu_last_used;
	guint _last_processor;
	guint64 _mem_usage;
	gboolean _mark_as_updated;
	UsageProcessStatus _status;
};

static gint UsageProcess_private_offset;
static gpointer usage_process_parent_class = NULL;

GType usage_process_get_type (void) G_GNUC_CONST;
GType usage_process_status_get_type (void) G_GNUC_CONST;
UsageProcess* usage_process_new (GPid pid,
                                 const gchar* cmdline);
UsageProcess* usage_process_construct (GType object_type,
                                       GPid pid,
                                       const gchar* cmdline);
static void usage_process_set_pid (UsageProcess* self,
                            GPid value);
static void usage_process_set_cmdline (UsageProcess* self,
                                const gchar* value);
static guint _usage_process_get_uid (UsageProcess* self);
static void usage_process_set_uid (UsageProcess* self,
                            guint value);
void usage_process_update_status (UsageProcess* self);
GPid usage_process_get_pid (UsageProcess* self);
static void usage_process_set_status (UsageProcess* self,
                               UsageProcessStatus value);
gdouble usage_process_get_cpu_load (UsageProcess* self);
void usage_process_set_mark_as_updated (UsageProcess* self,
                                        gboolean value);
const gchar* usage_process_get_cmdline (UsageProcess* self);
guint usage_process_get_uid (UsageProcess* self);
void usage_process_set_cpu_load (UsageProcess* self,
                                 gdouble value);
gdouble usage_process_get_x_cpu_load (UsageProcess* self);
void usage_process_set_x_cpu_load (UsageProcess* self,
                                   gdouble value);
guint64 usage_process_get_cpu_last_used (UsageProcess* self);
void usage_process_set_cpu_last_used (UsageProcess* self,
                                      guint64 value);
guint64 usage_process_get_x_cpu_last_used (UsageProcess* self);
void usage_process_set_x_cpu_last_used (UsageProcess* self,
                                        guint64 value);
guint usage_process_get_last_processor (UsageProcess* self);
void usage_process_set_last_processor (UsageProcess* self,
                                       guint value);
guint64 usage_process_get_mem_usage (UsageProcess* self);
void usage_process_set_mem_usage (UsageProcess* self,
                                  guint64 value);
gboolean usage_process_get_mark_as_updated (UsageProcess* self);
UsageProcessStatus usage_process_get_status (UsageProcess* self);
static void usage_process_finalize (GObject * obj);
static void _vala_usage_process_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_usage_process_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
usage_process_get_instance_private (UsageProcess* self)
{
	return G_STRUCT_MEMBER_P (self, UsageProcess_private_offset);
}

UsageProcess*
usage_process_construct (GType object_type,
                         GPid pid,
                         const gchar* cmdline)
{
	UsageProcess * self = NULL;
#line 40 "../src/process.vala"
	g_return_val_if_fail (cmdline != NULL, NULL);
#line 40 "../src/process.vala"
	self = (UsageProcess*) g_object_new (object_type, NULL);
#line 42 "../src/process.vala"
	usage_process_set_pid (self, pid);
#line 43 "../src/process.vala"
	usage_process_set_cmdline (self, cmdline);
#line 44 "../src/process.vala"
	usage_process_set_uid (self, _usage_process_get_uid (self));
#line 40 "../src/process.vala"
	return self;
#line 172 "process.c"
}

UsageProcess*
usage_process_new (GPid pid,
                   const gchar* cmdline)
{
#line 40 "../src/process.vala"
	return usage_process_construct (USAGE_TYPE_PROCESS, pid, cmdline);
#line 181 "process.c"
}

void
usage_process_update_status (UsageProcess* self)
{
	glibtop_proc_state proc_state = {0};
	GPid _tmp0_;
	glibtop_proc_state _tmp1_ = {0};
	glibtop_proc_state _tmp2_;
	gdouble _tmp3_;
#line 47 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/process.vala"
	_tmp0_ = self->priv->_pid;
#line 50 "../src/process.vala"
	glibtop_get_proc_state (&_tmp1_, _tmp0_);
#line 50 "../src/process.vala"
	proc_state = _tmp1_;
#line 52 "../src/process.vala"
	_tmp2_ = proc_state;
#line 52 "../src/process.vala"
	switch (_tmp2_.state) {
#line 52 "../src/process.vala"
		case GLIBTOP_PROCESS_RUNNING:
#line 52 "../src/process.vala"
		case GLIBTOP_PROCESS_UNINTERRUPTIBLE:
#line 208 "process.c"
		{
#line 56 "../src/process.vala"
			usage_process_set_status (self, USAGE_PROCESS_STATUS_RUNNING);
#line 57 "../src/process.vala"
			break;
#line 214 "process.c"
		}
#line 52 "../src/process.vala"
		case GLIBTOP_PROCESS_SWAPPING:
#line 52 "../src/process.vala"
		case GLIBTOP_PROCESS_INTERRUPTIBLE:
#line 52 "../src/process.vala"
		case GLIBTOP_PROCESS_STOPPED:
#line 222 "process.c"
		{
#line 61 "../src/process.vala"
			usage_process_set_status (self, USAGE_PROCESS_STATUS_SLEEPING);
#line 62 "../src/process.vala"
			break;
#line 228 "process.c"
		}
		default:
#line 52 "../src/process.vala"
		case GLIBTOP_PROCESS_DEAD:
#line 52 "../src/process.vala"
		case GLIBTOP_PROCESS_ZOMBIE:
#line 235 "process.c"
		{
#line 66 "../src/process.vala"
			usage_process_set_status (self, USAGE_PROCESS_STATUS_DEAD);
#line 67 "../src/process.vala"
			break;
#line 241 "process.c"
		}
	}
#line 70 "../src/process.vala"
	_tmp3_ = self->priv->_cpu_load;
#line 70 "../src/process.vala"
	if (_tmp3_ > ((gdouble) 0)) {
#line 71 "../src/process.vala"
		usage_process_set_status (self, USAGE_PROCESS_STATUS_RUNNING);
#line 250 "process.c"
	}
#line 73 "../src/process.vala"
	usage_process_set_mark_as_updated (self, TRUE);
#line 254 "process.c"
}

static guint
_usage_process_get_uid (UsageProcess* self)
{
	guint result = 0U;
	glibtop_proc_uid procUid = {0};
	GPid _tmp0_;
	glibtop_proc_uid _tmp1_ = {0};
	glibtop_proc_uid _tmp2_;
#line 76 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 79 "../src/process.vala"
	_tmp0_ = self->priv->_pid;
#line 79 "../src/process.vala"
	glibtop_get_proc_uid (&_tmp1_, _tmp0_);
#line 79 "../src/process.vala"
	procUid = _tmp1_;
#line 80 "../src/process.vala"
	_tmp2_ = procUid;
#line 80 "../src/process.vala"
	result = (guint) _tmp2_.uid;
#line 80 "../src/process.vala"
	return result;
#line 279 "process.c"
}

GPid
usage_process_get_pid (UsageProcess* self)
{
	GPid result;
#line 25 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../src/process.vala"
	result = self->priv->_pid;
#line 25 "../src/process.vala"
	return result;
#line 292 "process.c"
}

static void
usage_process_set_pid (UsageProcess* self,
                       GPid value)
{
#line 25 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/process.vala"
	if (usage_process_get_pid (self) != value) {
#line 25 "../src/process.vala"
		self->priv->_pid = value;
#line 25 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_PID_PROPERTY]);
#line 307 "process.c"
	}
}

const gchar*
usage_process_get_cmdline (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/process.vala"
	_tmp0_ = self->priv->_cmdline;
#line 26 "../src/process.vala"
	result = _tmp0_;
#line 26 "../src/process.vala"
	return result;
#line 324 "process.c"
}

static void
usage_process_set_cmdline (UsageProcess* self,
                           const gchar* value)
{
#line 26 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/process.vala"
	if (g_strcmp0 (value, usage_process_get_cmdline (self)) != 0) {
#line 335 "process.c"
		gchar* _tmp0_;
#line 26 "../src/process.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/process.vala"
		_g_free0 (self->priv->_cmdline);
#line 26 "../src/process.vala"
		self->priv->_cmdline = _tmp0_;
#line 26 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CMDLINE_PROPERTY]);
#line 345 "process.c"
	}
}

guint
usage_process_get_uid (UsageProcess* self)
{
	guint result;
#line 27 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 27 "../src/process.vala"
	result = self->priv->_uid;
#line 27 "../src/process.vala"
	return result;
#line 359 "process.c"
}

static void
usage_process_set_uid (UsageProcess* self,
                       guint value)
{
#line 27 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/process.vala"
	if (usage_process_get_uid (self) != value) {
#line 27 "../src/process.vala"
		self->priv->_uid = value;
#line 27 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_UID_PROPERTY]);
#line 374 "process.c"
	}
}

gdouble
usage_process_get_cpu_load (UsageProcess* self)
{
	gdouble result;
#line 29 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 29 "../src/process.vala"
	result = self->priv->_cpu_load;
#line 29 "../src/process.vala"
	return result;
#line 388 "process.c"
}

void
usage_process_set_cpu_load (UsageProcess* self,
                            gdouble value)
{
#line 29 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/process.vala"
	if (usage_process_get_cpu_load (self) != value) {
#line 29 "../src/process.vala"
		self->priv->_cpu_load = value;
#line 29 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CPU_LOAD_PROPERTY]);
#line 403 "process.c"
	}
}

gdouble
usage_process_get_x_cpu_load (UsageProcess* self)
{
	gdouble result;
#line 30 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 30 "../src/process.vala"
	result = self->priv->_x_cpu_load;
#line 30 "../src/process.vala"
	return result;
#line 417 "process.c"
}

void
usage_process_set_x_cpu_load (UsageProcess* self,
                              gdouble value)
{
#line 30 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/process.vala"
	if (usage_process_get_x_cpu_load (self) != value) {
#line 30 "../src/process.vala"
		self->priv->_x_cpu_load = value;
#line 30 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_X_CPU_LOAD_PROPERTY]);
#line 432 "process.c"
	}
}

guint64
usage_process_get_cpu_last_used (UsageProcess* self)
{
	guint64 result;
#line 31 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 31 "../src/process.vala"
	result = self->priv->_cpu_last_used;
#line 31 "../src/process.vala"
	return result;
#line 446 "process.c"
}

void
usage_process_set_cpu_last_used (UsageProcess* self,
                                 guint64 value)
{
#line 31 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/process.vala"
	if (usage_process_get_cpu_last_used (self) != value) {
#line 31 "../src/process.vala"
		self->priv->_cpu_last_used = value;
#line 31 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CPU_LAST_USED_PROPERTY]);
#line 461 "process.c"
	}
}

guint64
usage_process_get_x_cpu_last_used (UsageProcess* self)
{
	guint64 result;
#line 32 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 32 "../src/process.vala"
	result = self->priv->_x_cpu_last_used;
#line 32 "../src/process.vala"
	return result;
#line 475 "process.c"
}

void
usage_process_set_x_cpu_last_used (UsageProcess* self,
                                   guint64 value)
{
#line 32 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/process.vala"
	if (usage_process_get_x_cpu_last_used (self) != value) {
#line 32 "../src/process.vala"
		self->priv->_x_cpu_last_used = value;
#line 32 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY]);
#line 490 "process.c"
	}
}

guint
usage_process_get_last_processor (UsageProcess* self)
{
	guint result;
#line 33 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "../src/process.vala"
	result = self->priv->_last_processor;
#line 33 "../src/process.vala"
	return result;
#line 504 "process.c"
}

void
usage_process_set_last_processor (UsageProcess* self,
                                  guint value)
{
#line 33 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/process.vala"
	if (usage_process_get_last_processor (self) != value) {
#line 33 "../src/process.vala"
		self->priv->_last_processor = value;
#line 33 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_LAST_PROCESSOR_PROPERTY]);
#line 519 "process.c"
	}
}

guint64
usage_process_get_mem_usage (UsageProcess* self)
{
	guint64 result;
#line 35 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 35 "../src/process.vala"
	result = self->priv->_mem_usage;
#line 35 "../src/process.vala"
	return result;
#line 533 "process.c"
}

void
usage_process_set_mem_usage (UsageProcess* self,
                             guint64 value)
{
#line 35 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/process.vala"
	if (usage_process_get_mem_usage (self) != value) {
#line 35 "../src/process.vala"
		self->priv->_mem_usage = value;
#line 35 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_MEM_USAGE_PROPERTY]);
#line 548 "process.c"
	}
}

gboolean
usage_process_get_mark_as_updated (UsageProcess* self)
{
	gboolean result;
#line 37 "../src/process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "../src/process.vala"
	result = self->priv->_mark_as_updated;
#line 37 "../src/process.vala"
	return result;
#line 562 "process.c"
}

void
usage_process_set_mark_as_updated (UsageProcess* self,
                                   gboolean value)
{
#line 37 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/process.vala"
	if (usage_process_get_mark_as_updated (self) != value) {
#line 37 "../src/process.vala"
		self->priv->_mark_as_updated = value;
#line 37 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY]);
#line 577 "process.c"
	}
}

UsageProcessStatus
usage_process_get_status (UsageProcess* self)
{
	UsageProcessStatus result;
	UsageProcessStatus _tmp0_;
#line 38 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/process.vala"
	_tmp0_ = self->priv->_status;
#line 38 "../src/process.vala"
	result = _tmp0_;
#line 38 "../src/process.vala"
	return result;
#line 594 "process.c"
}

static void
usage_process_set_status (UsageProcess* self,
                          UsageProcessStatus value)
{
#line 38 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/process.vala"
	if (usage_process_get_status (self) != value) {
#line 38 "../src/process.vala"
		self->priv->_status = value;
#line 38 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_STATUS_PROPERTY]);
#line 609 "process.c"
	}
}

static void
usage_process_class_init (UsageProcessClass * klass,
                          gpointer klass_data)
{
#line 23 "../src/process.vala"
	usage_process_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/process.vala"
	g_type_class_adjust_private_offset (klass, &UsageProcess_private_offset);
#line 23 "../src/process.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_process_get_property;
#line 23 "../src/process.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_process_set_property;
#line 23 "../src/process.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_process_finalize;
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_PID_PROPERTY, usage_process_properties[USAGE_PROCESS_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CMDLINE_PROPERTY, usage_process_properties[USAGE_PROCESS_CMDLINE_PROPERTY] = g_param_spec_string ("cmdline", "cmdline", "cmdline", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_UID_PROPERTY, usage_process_properties[USAGE_PROCESS_UID_PROPERTY] = g_param_spec_uint ("uid", "uid", "uid", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CPU_LOAD_PROPERTY, usage_process_properties[USAGE_PROCESS_CPU_LOAD_PROPERTY] = g_param_spec_double ("cpu-load", "cpu-load", "cpu-load", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_X_CPU_LOAD_PROPERTY, usage_process_properties[USAGE_PROCESS_X_CPU_LOAD_PROPERTY] = g_param_spec_double ("x-cpu-load", "x-cpu-load", "x-cpu-load", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CPU_LAST_USED_PROPERTY, usage_process_properties[USAGE_PROCESS_CPU_LAST_USED_PROPERTY] = g_param_spec_uint64 ("cpu-last-used", "cpu-last-used", "cpu-last-used", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY, usage_process_properties[USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY] = g_param_spec_uint64 ("x-cpu-last-used", "x-cpu-last-used", "x-cpu-last-used", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_LAST_PROCESSOR_PROPERTY, usage_process_properties[USAGE_PROCESS_LAST_PROCESSOR_PROPERTY] = g_param_spec_uint ("last-processor", "last-processor", "last-processor", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_MEM_USAGE_PROPERTY, usage_process_properties[USAGE_PROCESS_MEM_USAGE_PROPERTY] = g_param_spec_uint64 ("mem-usage", "mem-usage", "mem-usage", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY, usage_process_properties[USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY] = g_param_spec_boolean ("mark-as-updated", "mark-as-updated", "mark-as-updated", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_STATUS_PROPERTY, usage_process_properties[USAGE_PROCESS_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", USAGE_TYPE_PROCESS_STATUS, USAGE_PROCESS_STATUS_SLEEPING, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 649 "process.c"
}

static void
usage_process_instance_init (UsageProcess * self,
                             gpointer klass)
{
#line 23 "../src/process.vala"
	self->priv = usage_process_get_instance_private (self);
#line 29 "../src/process.vala"
	self->priv->_cpu_load = (gdouble) 0;
#line 30 "../src/process.vala"
	self->priv->_x_cpu_load = (gdouble) 0;
#line 31 "../src/process.vala"
	self->priv->_cpu_last_used = (guint64) 0;
#line 32 "../src/process.vala"
	self->priv->_x_cpu_last_used = (guint64) 0;
#line 33 "../src/process.vala"
	self->priv->_last_processor = (guint) 0;
#line 35 "../src/process.vala"
	self->priv->_mem_usage = (guint64) 0;
#line 37 "../src/process.vala"
	self->priv->_mark_as_updated = TRUE;
#line 38 "../src/process.vala"
	self->priv->_status = USAGE_PROCESS_STATUS_SLEEPING;
#line 674 "process.c"
}

static void
usage_process_finalize (GObject * obj)
{
	UsageProcess * self;
#line 23 "../src/process.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_PROCESS, UsageProcess);
#line 26 "../src/process.vala"
	_g_free0 (self->priv->_cmdline);
#line 23 "../src/process.vala"
	G_OBJECT_CLASS (usage_process_parent_class)->finalize (obj);
#line 687 "process.c"
}

GType
usage_process_get_type (void)
{
	static volatile gsize usage_process_type_id__volatile = 0;
	if (g_once_init_enter (&usage_process_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageProcess), 0, (GInstanceInitFunc) usage_process_instance_init, NULL };
		GType usage_process_type_id;
		usage_process_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageProcess", &g_define_type_info, 0);
		UsageProcess_private_offset = g_type_add_instance_private (usage_process_type_id, sizeof (UsageProcessPrivate));
		g_once_init_leave (&usage_process_type_id__volatile, usage_process_type_id);
	}
	return usage_process_type_id__volatile;
}

static void
_vala_usage_process_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_PROCESS, UsageProcess);
#line 23 "../src/process.vala"
	switch (property_id) {
#line 23 "../src/process.vala"
		case USAGE_PROCESS_PID_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_int (value, usage_process_get_pid (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CMDLINE_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_string (value, usage_process_get_cmdline (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_UID_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint (value, usage_process_get_uid (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CPU_LOAD_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_double (value, usage_process_get_cpu_load (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LOAD_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_double (value, usage_process_get_x_cpu_load (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CPU_LAST_USED_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_cpu_last_used (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_x_cpu_last_used (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_LAST_PROCESSOR_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint (value, usage_process_get_last_processor (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_MEM_USAGE_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_mem_usage (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_boolean (value, usage_process_get_mark_as_updated (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_STATUS_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_enum (value, usage_process_get_status (self));
#line 23 "../src/process.vala"
		break;
#line 780 "process.c"
		default:
#line 23 "../src/process.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/process.vala"
		break;
#line 786 "process.c"
	}
}

static void
_vala_usage_process_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_PROCESS, UsageProcess);
#line 23 "../src/process.vala"
	switch (property_id) {
#line 23 "../src/process.vala"
		case USAGE_PROCESS_PID_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_pid (self, g_value_get_int (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CMDLINE_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_cmdline (self, g_value_get_string (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_UID_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_uid (self, g_value_get_uint (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CPU_LOAD_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_cpu_load (self, g_value_get_double (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LOAD_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_x_cpu_load (self, g_value_get_double (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CPU_LAST_USED_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_cpu_last_used (self, g_value_get_uint64 (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_x_cpu_last_used (self, g_value_get_uint64 (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_LAST_PROCESSOR_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_last_processor (self, g_value_get_uint (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_MEM_USAGE_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_mem_usage (self, g_value_get_uint64 (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_mark_as_updated (self, g_value_get_boolean (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_STATUS_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_status (self, g_value_get_enum (value));
#line 23 "../src/process.vala"
		break;
#line 866 "process.c"
		default:
#line 23 "../src/process.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/process.vala"
		break;
#line 872 "process.c"
	}
}

GType
usage_process_status_get_type (void)
{
	static volatile gsize usage_process_status_type_id__volatile = 0;
	if (g_once_init_enter (&usage_process_status_type_id__volatile)) {
		static const GEnumValue values[] = {{USAGE_PROCESS_STATUS_RUNNING, "USAGE_PROCESS_STATUS_RUNNING", "running"}, {USAGE_PROCESS_STATUS_SLEEPING, "USAGE_PROCESS_STATUS_SLEEPING", "sleeping"}, {USAGE_PROCESS_STATUS_DEAD, "USAGE_PROCESS_STATUS_DEAD", "dead"}, {0, NULL, NULL}};
		GType usage_process_status_type_id;
		usage_process_status_type_id = g_enum_register_static ("UsageProcessStatus", values);
		g_once_init_leave (&usage_process_status_type_id__volatile, usage_process_status_type_id);
	}
	return usage_process_status_type_id__volatile;
}

