/* storage-item.c generated by valac 0.44.1, the Vala compiler
 * generated from storage-item.vala, do not modify */

/* storage-item.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	USAGE_STORAGE_ITEM_POSITION_FIRST,
	USAGE_STORAGE_ITEM_POSITION_SECOND,
	USAGE_STORAGE_ITEM_POSITION_THIRD,
	USAGE_STORAGE_ITEM_POSITION_ANYWHERE,
	USAGE_STORAGE_ITEM_POSITION_PENULTIMATE,
	USAGE_STORAGE_ITEM_POSITION_LAST
} UsageStorageItemPosition;

#define USAGE_TYPE_STORAGE_ITEM_POSITION (usage_storage_item_position_get_type ())
typedef enum  {
	USAGE_STORAGE_ITEM_TYPE_STORAGE,
	USAGE_STORAGE_ITEM_TYPE_SYSTEM,
	USAGE_STORAGE_ITEM_TYPE_DOCUMENTS,
	USAGE_STORAGE_ITEM_TYPE_DOWNLOADS,
	USAGE_STORAGE_ITEM_TYPE_DESKTOP,
	USAGE_STORAGE_ITEM_TYPE_MUSIC,
	USAGE_STORAGE_ITEM_TYPE_PICTURES,
	USAGE_STORAGE_ITEM_TYPE_VIDEOS,
	USAGE_STORAGE_ITEM_TYPE_TRASH,
	USAGE_STORAGE_ITEM_TYPE_TRASHFILE,
	USAGE_STORAGE_ITEM_TYPE_TRASHSUBFILE,
	USAGE_STORAGE_ITEM_TYPE_USER,
	USAGE_STORAGE_ITEM_TYPE_AVAILABLE,
	USAGE_STORAGE_ITEM_TYPE_FILE,
	USAGE_STORAGE_ITEM_TYPE_DIRECTORY
} UsageStorageItemType;

#define USAGE_TYPE_STORAGE_ITEM_TYPE (usage_storage_item_type_get_type ())

#define USAGE_TYPE_STORAGE_ITEM (usage_storage_item_get_type ())
#define USAGE_STORAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_ITEM, UsageStorageItem))
#define USAGE_STORAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_ITEM, UsageStorageItemClass))
#define USAGE_IS_STORAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_ITEM))
#define USAGE_IS_STORAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_ITEM))
#define USAGE_STORAGE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_ITEM, UsageStorageItemClass))

typedef struct _UsageStorageItem UsageStorageItem;
typedef struct _UsageStorageItemClass UsageStorageItemClass;
typedef struct _UsageStorageItemPrivate UsageStorageItemPrivate;
enum  {
	USAGE_STORAGE_ITEM_0_PROPERTY,
	USAGE_STORAGE_ITEM_NUM_PROPERTIES
};
static GParamSpec* usage_storage_item_properties[USAGE_STORAGE_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UsageStorageItem {
	GObject parent_instance;
	UsageStorageItemPrivate * priv;
};

struct _UsageStorageItemClass {
	GObjectClass parent_class;
};

struct _UsageStorageItemPrivate {
	gchar* name;
	gchar* path;
	UsageStorageItemType type;
	UsageStorageItemType* parent;
	guint64 size;
	gdouble percentage;
	UsageStorageItemPosition prefered_position;
	gint section;
	GdkRGBA color;
};

static gint UsageStorageItem_private_offset;
static gpointer usage_storage_item_parent_class = NULL;

GType usage_storage_item_position_get_type (void) G_GNUC_CONST;
GType usage_storage_item_type_get_type (void) G_GNUC_CONST;
GType usage_storage_item_get_type (void) G_GNUC_CONST;
UsageStorageItem* usage_storage_item_new_item (UsageStorageItemType type,
                                               UsageStorageItemType* parent,
                                               const gchar* name,
                                               const gchar* path,
                                               guint64 size,
                                               gdouble percentage,
                                               gint section,
                                               UsageStorageItemPosition prefered_position);
UsageStorageItem* usage_storage_item_construct_item (GType object_type,
                                                     UsageStorageItemType type,
                                                     UsageStorageItemType* parent,
                                                     const gchar* name,
                                                     const gchar* path,
                                                     guint64 size,
                                                     gdouble percentage,
                                                     gint section,
                                                     UsageStorageItemPosition prefered_position);
static UsageStorageItemType* _usage_storage_item_type_dup (UsageStorageItemType* self);
UsageStorageItem* usage_storage_item_new_directory (UsageStorageItemType parent,
                                                    const gchar* name,
                                                    const gchar* path,
                                                    guint64 size,
                                                    gdouble percentage);
UsageStorageItem* usage_storage_item_construct_directory (GType object_type,
                                                          UsageStorageItemType parent,
                                                          const gchar* name,
                                                          const gchar* path,
                                                          guint64 size,
                                                          gdouble percentage);
UsageStorageItem* usage_storage_item_new_file (UsageStorageItemType parent,
                                               const gchar* name,
                                               const gchar* path,
                                               guint64 size,
                                               gdouble percentage);
UsageStorageItem* usage_storage_item_construct_file (GType object_type,
                                                     UsageStorageItemType parent,
                                                     const gchar* name,
                                                     const gchar* path,
                                                     guint64 size,
                                                     gdouble percentage);
UsageStorageItem* usage_storage_item_new_trash (const gchar* path,
                                                guint64 size,
                                                gdouble percentage,
                                                gint section);
UsageStorageItem* usage_storage_item_construct_trash (GType object_type,
                                                      const gchar* path,
                                                      guint64 size,
                                                      gdouble percentage,
                                                      gint section);
UsageStorageItem* usage_storage_item_new_storage (const gchar* name,
                                                  const gchar* path,
                                                  guint64 size,
                                                  gint section);
UsageStorageItem* usage_storage_item_construct_storage (GType object_type,
                                                        const gchar* name,
                                                        const gchar* path,
                                                        guint64 size,
                                                        gint section);
UsageStorageItem* usage_storage_item_new_system (guint64 size,
                                                 gdouble percentage,
                                                 gint section);
UsageStorageItem* usage_storage_item_construct_system (GType object_type,
                                                       guint64 size,
                                                       gdouble percentage,
                                                       gint section);
UsageStorageItem* usage_storage_item_new_available (guint64 size,
                                                    gdouble percentage,
                                                    gint section);
UsageStorageItem* usage_storage_item_construct_available (GType object_type,
                                                          guint64 size,
                                                          gdouble percentage,
                                                          gint section);
UsageStorageItemPosition usage_storage_item_get_prefered_position (UsageStorageItem* self);
void usage_storage_item_set_color (UsageStorageItem* self,
                                   GdkRGBA* color);
void usage_storage_item_get_color (UsageStorageItem* self,
                                   GdkRGBA* result);
gint usage_storage_item_get_section (UsageStorageItem* self);
guint64 usage_storage_item_get_size (UsageStorageItem* self);
gdouble usage_storage_item_get_percentage (UsageStorageItem* self);
gchar* usage_storage_item_get_name (UsageStorageItem* self);
UsageStorageItemType usage_storage_item_get_item_type (UsageStorageItem* self);
UsageStorageItemType* usage_storage_item_get_parent_type (UsageStorageItem* self);
gchar* usage_storage_item_get_path (UsageStorageItem* self);
UsageStorageItem* usage_storage_item_new (void);
UsageStorageItem* usage_storage_item_construct (GType object_type);
static void usage_storage_item_finalize (GObject * obj);

GType
usage_storage_item_position_get_type (void)
{
	static volatile gsize usage_storage_item_position_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_item_position_type_id__volatile)) {
		static const GEnumValue values[] = {{USAGE_STORAGE_ITEM_POSITION_FIRST, "USAGE_STORAGE_ITEM_POSITION_FIRST", "first"}, {USAGE_STORAGE_ITEM_POSITION_SECOND, "USAGE_STORAGE_ITEM_POSITION_SECOND", "second"}, {USAGE_STORAGE_ITEM_POSITION_THIRD, "USAGE_STORAGE_ITEM_POSITION_THIRD", "third"}, {USAGE_STORAGE_ITEM_POSITION_ANYWHERE, "USAGE_STORAGE_ITEM_POSITION_ANYWHERE", "anywhere"}, {USAGE_STORAGE_ITEM_POSITION_PENULTIMATE, "USAGE_STORAGE_ITEM_POSITION_PENULTIMATE", "penultimate"}, {USAGE_STORAGE_ITEM_POSITION_LAST, "USAGE_STORAGE_ITEM_POSITION_LAST", "last"}, {0, NULL, NULL}};
		GType usage_storage_item_position_type_id;
		usage_storage_item_position_type_id = g_enum_register_static ("UsageStorageItemPosition", values);
		g_once_init_leave (&usage_storage_item_position_type_id__volatile, usage_storage_item_position_type_id);
	}
	return usage_storage_item_position_type_id__volatile;
}

GType
usage_storage_item_type_get_type (void)
{
	static volatile gsize usage_storage_item_type_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_item_type_type_id__volatile)) {
		static const GEnumValue values[] = {{USAGE_STORAGE_ITEM_TYPE_STORAGE, "USAGE_STORAGE_ITEM_TYPE_STORAGE", "storage"}, {USAGE_STORAGE_ITEM_TYPE_SYSTEM, "USAGE_STORAGE_ITEM_TYPE_SYSTEM", "system"}, {USAGE_STORAGE_ITEM_TYPE_DOCUMENTS, "USAGE_STORAGE_ITEM_TYPE_DOCUMENTS", "documents"}, {USAGE_STORAGE_ITEM_TYPE_DOWNLOADS, "USAGE_STORAGE_ITEM_TYPE_DOWNLOADS", "downloads"}, {USAGE_STORAGE_ITEM_TYPE_DESKTOP, "USAGE_STORAGE_ITEM_TYPE_DESKTOP", "desktop"}, {USAGE_STORAGE_ITEM_TYPE_MUSIC, "USAGE_STORAGE_ITEM_TYPE_MUSIC", "music"}, {USAGE_STORAGE_ITEM_TYPE_PICTURES, "USAGE_STORAGE_ITEM_TYPE_PICTURES", "pictures"}, {USAGE_STORAGE_ITEM_TYPE_VIDEOS, "USAGE_STORAGE_ITEM_TYPE_VIDEOS", "videos"}, {USAGE_STORAGE_ITEM_TYPE_TRASH, "USAGE_STORAGE_ITEM_TYPE_TRASH", "trash"}, {USAGE_STORAGE_ITEM_TYPE_TRASHFILE, "USAGE_STORAGE_ITEM_TYPE_TRASHFILE", "trashfile"}, {USAGE_STORAGE_ITEM_TYPE_TRASHSUBFILE, "USAGE_STORAGE_ITEM_TYPE_TRASHSUBFILE", "trashsubfile"}, {USAGE_STORAGE_ITEM_TYPE_USER, "USAGE_STORAGE_ITEM_TYPE_USER", "user"}, {USAGE_STORAGE_ITEM_TYPE_AVAILABLE, "USAGE_STORAGE_ITEM_TYPE_AVAILABLE", "available"}, {USAGE_STORAGE_ITEM_TYPE_FILE, "USAGE_STORAGE_ITEM_TYPE_FILE", "file"}, {USAGE_STORAGE_ITEM_TYPE_DIRECTORY, "USAGE_STORAGE_ITEM_TYPE_DIRECTORY", "directory"}, {0, NULL, NULL}};
		GType usage_storage_item_type_type_id;
		usage_storage_item_type_type_id = g_enum_register_static ("UsageStorageItemType", values);
		g_once_init_leave (&usage_storage_item_type_type_id__volatile, usage_storage_item_type_type_id);
	}
	return usage_storage_item_type_type_id__volatile;
}

static inline gpointer
usage_storage_item_get_instance_private (UsageStorageItem* self)
{
	return G_STRUCT_MEMBER_P (self, UsageStorageItem_private_offset);
}

static UsageStorageItemType*
_usage_storage_item_type_dup (UsageStorageItemType* self)
{
	UsageStorageItemType* dup;
#line 67 "../src/storage-item.vala"
	dup = g_new0 (UsageStorageItemType, 1);
#line 67 "../src/storage-item.vala"
	memcpy (dup, self, sizeof (UsageStorageItemType));
#line 67 "../src/storage-item.vala"
	return dup;
#line 238 "storage-item.c"
}

static gpointer
__usage_storage_item_type_dup0 (gpointer self)
{
#line 67 "../src/storage-item.vala"
	return self ? _usage_storage_item_type_dup (self) : NULL;
#line 246 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_construct_item (GType object_type,
                                   UsageStorageItemType type,
                                   UsageStorageItemType* parent,
                                   const gchar* name,
                                   const gchar* path,
                                   guint64 size,
                                   gdouble percentage,
                                   gint section,
                                   UsageStorageItemPosition prefered_position)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 64 "../src/storage-item.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 64 "../src/storage-item.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 64 "../src/storage-item.vala"
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
#line 66 "../src/storage-item.vala"
	self->priv->type = type;
#line 67 "../src/storage-item.vala"
	_tmp0_ = __usage_storage_item_type_dup0 (parent);
#line 67 "../src/storage-item.vala"
	_g_free0 (self->priv->parent);
#line 67 "../src/storage-item.vala"
	self->priv->parent = _tmp0_;
#line 68 "../src/storage-item.vala"
	_tmp1_ = g_strdup (name);
#line 68 "../src/storage-item.vala"
	_g_free0 (self->priv->name);
#line 68 "../src/storage-item.vala"
	self->priv->name = _tmp1_;
#line 69 "../src/storage-item.vala"
	_tmp2_ = g_strdup (path);
#line 69 "../src/storage-item.vala"
	_g_free0 (self->priv->path);
#line 69 "../src/storage-item.vala"
	self->priv->path = _tmp2_;
#line 70 "../src/storage-item.vala"
	self->priv->size = size;
#line 71 "../src/storage-item.vala"
	self->priv->percentage = percentage;
#line 72 "../src/storage-item.vala"
	self->priv->section = section;
#line 73 "../src/storage-item.vala"
	self->priv->prefered_position = prefered_position;
#line 64 "../src/storage-item.vala"
	return self;
#line 300 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_new_item (UsageStorageItemType type,
                             UsageStorageItemType* parent,
                             const gchar* name,
                             const gchar* path,
                             guint64 size,
                             gdouble percentage,
                             gint section,
                             UsageStorageItemPosition prefered_position)
{
#line 64 "../src/storage-item.vala"
	return usage_storage_item_construct_item (USAGE_TYPE_STORAGE_ITEM, type, parent, name, path, size, percentage, section, prefered_position);
#line 315 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_construct_directory (GType object_type,
                                        UsageStorageItemType parent,
                                        const gchar* name,
                                        const gchar* path,
                                        guint64 size,
                                        gdouble percentage)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 76 "../src/storage-item.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 76 "../src/storage-item.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 76 "../src/storage-item.vala"
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
#line 78 "../src/storage-item.vala"
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_DIRECTORY;
#line 79 "../src/storage-item.vala"
	_tmp0_ = __usage_storage_item_type_dup0 (&parent);
#line 79 "../src/storage-item.vala"
	_g_free0 (self->priv->parent);
#line 79 "../src/storage-item.vala"
	self->priv->parent = _tmp0_;
#line 80 "../src/storage-item.vala"
	_tmp1_ = g_strdup (name);
#line 80 "../src/storage-item.vala"
	_g_free0 (self->priv->name);
#line 80 "../src/storage-item.vala"
	self->priv->name = _tmp1_;
#line 81 "../src/storage-item.vala"
	_tmp2_ = g_strdup (path);
#line 81 "../src/storage-item.vala"
	_g_free0 (self->priv->path);
#line 81 "../src/storage-item.vala"
	self->priv->path = _tmp2_;
#line 82 "../src/storage-item.vala"
	self->priv->size = size;
#line 83 "../src/storage-item.vala"
	self->priv->percentage = percentage;
#line 84 "../src/storage-item.vala"
	self->priv->section = 0;
#line 85 "../src/storage-item.vala"
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_ANYWHERE;
#line 76 "../src/storage-item.vala"
	return self;
#line 366 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_new_directory (UsageStorageItemType parent,
                                  const gchar* name,
                                  const gchar* path,
                                  guint64 size,
                                  gdouble percentage)
{
#line 76 "../src/storage-item.vala"
	return usage_storage_item_construct_directory (USAGE_TYPE_STORAGE_ITEM, parent, name, path, size, percentage);
#line 378 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_construct_file (GType object_type,
                                   UsageStorageItemType parent,
                                   const gchar* name,
                                   const gchar* path,
                                   guint64 size,
                                   gdouble percentage)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 88 "../src/storage-item.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 88 "../src/storage-item.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 88 "../src/storage-item.vala"
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
#line 90 "../src/storage-item.vala"
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_FILE;
#line 91 "../src/storage-item.vala"
	_tmp0_ = __usage_storage_item_type_dup0 (&parent);
#line 91 "../src/storage-item.vala"
	_g_free0 (self->priv->parent);
#line 91 "../src/storage-item.vala"
	self->priv->parent = _tmp0_;
#line 92 "../src/storage-item.vala"
	_tmp1_ = g_strdup (name);
#line 92 "../src/storage-item.vala"
	_g_free0 (self->priv->name);
#line 92 "../src/storage-item.vala"
	self->priv->name = _tmp1_;
#line 93 "../src/storage-item.vala"
	_tmp2_ = g_strdup (path);
#line 93 "../src/storage-item.vala"
	_g_free0 (self->priv->path);
#line 93 "../src/storage-item.vala"
	self->priv->path = _tmp2_;
#line 94 "../src/storage-item.vala"
	self->priv->size = size;
#line 95 "../src/storage-item.vala"
	self->priv->percentage = percentage;
#line 96 "../src/storage-item.vala"
	self->priv->section = 0;
#line 97 "../src/storage-item.vala"
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_ANYWHERE;
#line 88 "../src/storage-item.vala"
	return self;
#line 429 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_new_file (UsageStorageItemType parent,
                             const gchar* name,
                             const gchar* path,
                             guint64 size,
                             gdouble percentage)
{
#line 88 "../src/storage-item.vala"
	return usage_storage_item_construct_file (USAGE_TYPE_STORAGE_ITEM, parent, name, path, size, percentage);
#line 441 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_construct_trash (GType object_type,
                                    const gchar* path,
                                    guint64 size,
                                    gdouble percentage,
                                    gint section)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType _tmp0_;
	UsageStorageItemType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 100 "../src/storage-item.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 100 "../src/storage-item.vala"
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
#line 102 "../src/storage-item.vala"
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_TRASH;
#line 103 "../src/storage-item.vala"
	_tmp0_ = USAGE_STORAGE_ITEM_TYPE_TRASH;
#line 103 "../src/storage-item.vala"
	_tmp1_ = __usage_storage_item_type_dup0 (&_tmp0_);
#line 103 "../src/storage-item.vala"
	_g_free0 (self->priv->parent);
#line 103 "../src/storage-item.vala"
	self->priv->parent = _tmp1_;
#line 104 "../src/storage-item.vala"
	_tmp2_ = g_strdup (_ ("Trash"));
#line 104 "../src/storage-item.vala"
	_g_free0 (self->priv->name);
#line 104 "../src/storage-item.vala"
	self->priv->name = _tmp2_;
#line 105 "../src/storage-item.vala"
	_tmp3_ = g_strdup (path);
#line 105 "../src/storage-item.vala"
	_g_free0 (self->priv->path);
#line 105 "../src/storage-item.vala"
	self->priv->path = _tmp3_;
#line 106 "../src/storage-item.vala"
	self->priv->size = size;
#line 107 "../src/storage-item.vala"
	self->priv->percentage = percentage;
#line 108 "../src/storage-item.vala"
	self->priv->section = section;
#line 109 "../src/storage-item.vala"
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_PENULTIMATE;
#line 100 "../src/storage-item.vala"
	return self;
#line 492 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_new_trash (const gchar* path,
                              guint64 size,
                              gdouble percentage,
                              gint section)
{
#line 100 "../src/storage-item.vala"
	return usage_storage_item_construct_trash (USAGE_TYPE_STORAGE_ITEM, path, size, percentage, section);
#line 503 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_construct_storage (GType object_type,
                                      const gchar* name,
                                      const gchar* path,
                                      guint64 size,
                                      gint section)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType _tmp0_;
	UsageStorageItemType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 112 "../src/storage-item.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 112 "../src/storage-item.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 112 "../src/storage-item.vala"
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
#line 114 "../src/storage-item.vala"
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_STORAGE;
#line 115 "../src/storage-item.vala"
	_tmp0_ = USAGE_STORAGE_ITEM_TYPE_STORAGE;
#line 115 "../src/storage-item.vala"
	_tmp1_ = __usage_storage_item_type_dup0 (&_tmp0_);
#line 115 "../src/storage-item.vala"
	_g_free0 (self->priv->parent);
#line 115 "../src/storage-item.vala"
	self->priv->parent = _tmp1_;
#line 116 "../src/storage-item.vala"
	_tmp2_ = g_strdup (name);
#line 116 "../src/storage-item.vala"
	_g_free0 (self->priv->name);
#line 116 "../src/storage-item.vala"
	self->priv->name = _tmp2_;
#line 117 "../src/storage-item.vala"
	_tmp3_ = g_strdup (path);
#line 117 "../src/storage-item.vala"
	_g_free0 (self->priv->path);
#line 117 "../src/storage-item.vala"
	self->priv->path = _tmp3_;
#line 118 "../src/storage-item.vala"
	self->priv->size = size;
#line 119 "../src/storage-item.vala"
	self->priv->percentage = (gdouble) 0;
#line 120 "../src/storage-item.vala"
	self->priv->section = section;
#line 121 "../src/storage-item.vala"
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_FIRST;
#line 112 "../src/storage-item.vala"
	return self;
#line 556 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_new_storage (const gchar* name,
                                const gchar* path,
                                guint64 size,
                                gint section)
{
#line 112 "../src/storage-item.vala"
	return usage_storage_item_construct_storage (USAGE_TYPE_STORAGE_ITEM, name, path, size, section);
#line 567 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_construct_system (GType object_type,
                                     guint64 size,
                                     gdouble percentage,
                                     gint section)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType _tmp0_;
	UsageStorageItemType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 124 "../src/storage-item.vala"
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
#line 126 "../src/storage-item.vala"
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_SYSTEM;
#line 127 "../src/storage-item.vala"
	_tmp0_ = USAGE_STORAGE_ITEM_TYPE_SYSTEM;
#line 127 "../src/storage-item.vala"
	_tmp1_ = __usage_storage_item_type_dup0 (&_tmp0_);
#line 127 "../src/storage-item.vala"
	_g_free0 (self->priv->parent);
#line 127 "../src/storage-item.vala"
	self->priv->parent = _tmp1_;
#line 128 "../src/storage-item.vala"
	_tmp2_ = g_strdup (_ ("Operating System"));
#line 128 "../src/storage-item.vala"
	_g_free0 (self->priv->name);
#line 128 "../src/storage-item.vala"
	self->priv->name = _tmp2_;
#line 129 "../src/storage-item.vala"
	_tmp3_ = g_strdup ("");
#line 129 "../src/storage-item.vala"
	_g_free0 (self->priv->path);
#line 129 "../src/storage-item.vala"
	self->priv->path = _tmp3_;
#line 130 "../src/storage-item.vala"
	self->priv->size = size;
#line 131 "../src/storage-item.vala"
	self->priv->percentage = percentage;
#line 132 "../src/storage-item.vala"
	self->priv->section = section;
#line 133 "../src/storage-item.vala"
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_SECOND;
#line 124 "../src/storage-item.vala"
	return self;
#line 615 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_new_system (guint64 size,
                               gdouble percentage,
                               gint section)
{
#line 124 "../src/storage-item.vala"
	return usage_storage_item_construct_system (USAGE_TYPE_STORAGE_ITEM, size, percentage, section);
#line 625 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_construct_available (GType object_type,
                                        guint64 size,
                                        gdouble percentage,
                                        gint section)
{
	UsageStorageItem * self = NULL;
	UsageStorageItemType _tmp0_;
	UsageStorageItemType* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 136 "../src/storage-item.vala"
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
#line 138 "../src/storage-item.vala"
	self->priv->type = USAGE_STORAGE_ITEM_TYPE_AVAILABLE;
#line 139 "../src/storage-item.vala"
	_tmp0_ = USAGE_STORAGE_ITEM_TYPE_AVAILABLE;
#line 139 "../src/storage-item.vala"
	_tmp1_ = __usage_storage_item_type_dup0 (&_tmp0_);
#line 139 "../src/storage-item.vala"
	_g_free0 (self->priv->parent);
#line 139 "../src/storage-item.vala"
	self->priv->parent = _tmp1_;
#line 140 "../src/storage-item.vala"
	_tmp2_ = g_strdup (_ ("Available"));
#line 140 "../src/storage-item.vala"
	_g_free0 (self->priv->name);
#line 140 "../src/storage-item.vala"
	self->priv->name = _tmp2_;
#line 141 "../src/storage-item.vala"
	_tmp3_ = g_strdup ("");
#line 141 "../src/storage-item.vala"
	_g_free0 (self->priv->path);
#line 141 "../src/storage-item.vala"
	self->priv->path = _tmp3_;
#line 142 "../src/storage-item.vala"
	self->priv->size = size;
#line 143 "../src/storage-item.vala"
	self->priv->percentage = percentage;
#line 144 "../src/storage-item.vala"
	self->priv->section = section;
#line 145 "../src/storage-item.vala"
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_LAST;
#line 136 "../src/storage-item.vala"
	return self;
#line 673 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_new_available (guint64 size,
                                  gdouble percentage,
                                  gint section)
{
#line 136 "../src/storage-item.vala"
	return usage_storage_item_construct_available (USAGE_TYPE_STORAGE_ITEM, size, percentage, section);
#line 683 "storage-item.c"
}

UsageStorageItemPosition
usage_storage_item_get_prefered_position (UsageStorageItem* self)
{
	UsageStorageItemPosition result = 0;
	UsageStorageItemPosition _tmp0_;
#line 148 "../src/storage-item.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 150 "../src/storage-item.vala"
	_tmp0_ = self->priv->prefered_position;
#line 150 "../src/storage-item.vala"
	result = _tmp0_;
#line 150 "../src/storage-item.vala"
	return result;
#line 699 "storage-item.c"
}

void
usage_storage_item_set_color (UsageStorageItem* self,
                              GdkRGBA* color)
{
	GdkRGBA _tmp0_;
#line 153 "../src/storage-item.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/storage-item.vala"
	g_return_if_fail (color != NULL);
#line 155 "../src/storage-item.vala"
	_tmp0_ = *color;
#line 155 "../src/storage-item.vala"
	self->priv->color = _tmp0_;
#line 715 "storage-item.c"
}

void
usage_storage_item_get_color (UsageStorageItem* self,
                              GdkRGBA* result)
{
	GdkRGBA _tmp0_;
#line 158 "../src/storage-item.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/storage-item.vala"
	_tmp0_ = self->priv->color;
#line 160 "../src/storage-item.vala"
	*result = _tmp0_;
#line 160 "../src/storage-item.vala"
	return;
#line 731 "storage-item.c"
}

gint
usage_storage_item_get_section (UsageStorageItem* self)
{
	gint result = 0;
#line 163 "../src/storage-item.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 165 "../src/storage-item.vala"
	result = self->priv->section;
#line 165 "../src/storage-item.vala"
	return result;
#line 744 "storage-item.c"
}

guint64
usage_storage_item_get_size (UsageStorageItem* self)
{
	guint64 result = 0ULL;
#line 168 "../src/storage-item.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 170 "../src/storage-item.vala"
	result = self->priv->size;
#line 170 "../src/storage-item.vala"
	return result;
#line 757 "storage-item.c"
}

gdouble
usage_storage_item_get_percentage (UsageStorageItem* self)
{
	gdouble result = 0.0;
#line 173 "../src/storage-item.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 175 "../src/storage-item.vala"
	result = self->priv->percentage;
#line 175 "../src/storage-item.vala"
	return result;
#line 770 "storage-item.c"
}

gchar*
usage_storage_item_get_name (UsageStorageItem* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 178 "../src/storage-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 180 "../src/storage-item.vala"
	_tmp0_ = self->priv->name;
#line 180 "../src/storage-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 180 "../src/storage-item.vala"
	result = _tmp1_;
#line 180 "../src/storage-item.vala"
	return result;
#line 789 "storage-item.c"
}

UsageStorageItemType
usage_storage_item_get_item_type (UsageStorageItem* self)
{
	UsageStorageItemType result = 0;
	UsageStorageItemType _tmp0_;
#line 183 "../src/storage-item.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 185 "../src/storage-item.vala"
	_tmp0_ = self->priv->type;
#line 185 "../src/storage-item.vala"
	result = _tmp0_;
#line 185 "../src/storage-item.vala"
	return result;
#line 805 "storage-item.c"
}

UsageStorageItemType*
usage_storage_item_get_parent_type (UsageStorageItem* self)
{
	UsageStorageItemType* result = NULL;
	UsageStorageItemType* _tmp0_;
	UsageStorageItemType* _tmp1_;
#line 188 "../src/storage-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../src/storage-item.vala"
	_tmp0_ = self->priv->parent;
#line 190 "../src/storage-item.vala"
	_tmp1_ = __usage_storage_item_type_dup0 (_tmp0_);
#line 190 "../src/storage-item.vala"
	result = _tmp1_;
#line 190 "../src/storage-item.vala"
	return result;
#line 824 "storage-item.c"
}

gchar*
usage_storage_item_get_path (UsageStorageItem* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 193 "../src/storage-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 195 "../src/storage-item.vala"
	_tmp0_ = self->priv->path;
#line 195 "../src/storage-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 195 "../src/storage-item.vala"
	result = _tmp1_;
#line 195 "../src/storage-item.vala"
	return result;
#line 843 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_construct (GType object_type)
{
	UsageStorageItem * self = NULL;
#line 52 "../src/storage-item.vala"
	self = (UsageStorageItem*) g_object_new (object_type, NULL);
#line 52 "../src/storage-item.vala"
	return self;
#line 854 "storage-item.c"
}

UsageStorageItem*
usage_storage_item_new (void)
{
#line 52 "../src/storage-item.vala"
	return usage_storage_item_construct (USAGE_TYPE_STORAGE_ITEM);
#line 862 "storage-item.c"
}

static void
usage_storage_item_class_init (UsageStorageItemClass * klass,
                               gpointer klass_data)
{
#line 52 "../src/storage-item.vala"
	usage_storage_item_parent_class = g_type_class_peek_parent (klass);
#line 52 "../src/storage-item.vala"
	g_type_class_adjust_private_offset (klass, &UsageStorageItem_private_offset);
#line 52 "../src/storage-item.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_storage_item_finalize;
#line 875 "storage-item.c"
}

static void
usage_storage_item_instance_init (UsageStorageItem * self,
                                  gpointer klass)
{
#line 52 "../src/storage-item.vala"
	self->priv = usage_storage_item_get_instance_private (self);
#line 60 "../src/storage-item.vala"
	self->priv->prefered_position = USAGE_STORAGE_ITEM_POSITION_ANYWHERE;
#line 886 "storage-item.c"
}

static void
usage_storage_item_finalize (GObject * obj)
{
	UsageStorageItem * self;
#line 52 "../src/storage-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_STORAGE_ITEM, UsageStorageItem);
#line 54 "../src/storage-item.vala"
	_g_free0 (self->priv->name);
#line 55 "../src/storage-item.vala"
	_g_free0 (self->priv->path);
#line 57 "../src/storage-item.vala"
	_g_free0 (self->priv->parent);
#line 52 "../src/storage-item.vala"
	G_OBJECT_CLASS (usage_storage_item_parent_class)->finalize (obj);
#line 903 "storage-item.c"
}

GType
usage_storage_item_get_type (void)
{
	static volatile gsize usage_storage_item_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageStorageItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_storage_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageStorageItem), 0, (GInstanceInitFunc) usage_storage_item_instance_init, NULL };
		GType usage_storage_item_type_id;
		usage_storage_item_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageStorageItem", &g_define_type_info, 0);
		UsageStorageItem_private_offset = g_type_add_instance_private (usage_storage_item_type_id, sizeof (UsageStorageItemPrivate));
		g_once_init_leave (&usage_storage_item_type_id__volatile, usage_storage_item_type_id);
	}
	return usage_storage_item_type_id__volatile;
}

